:
#
# version 3.0 Sep 25 11:21:02 PDT 1998

umask 022

# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1992, 1993, 1994, 1995, 1996, 1997, 1998, 1999, 2000
#
# The copyright holder disclaims all responsibility or liability with 
# respect to its usage or its effect upon hardware or computer 
# systems, and maintains copyright as set out in the "LICENSE" 
# document which accompanies distribution. 
 

TITANHOME=`pwd`
PATH=/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`
# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
	exit 1
	fi

. misc_functions.sh

Intro() {

cat << EOF_INTRO

 check /etc/aliases for any programs that mail is piped to and comment out


EOF_INTRO
}

Check() {

awk '/ *#/ {next} ; \
	/\|/ {print $0}' /etc/aliases > ./tmpfile.$$

if test -s ./tmpfile.$$ ;
then
	t_echo 0 ""
	t_echo 0 "Existing mail alias(es)":
	cat ./tmpfile.$$
	t_echo 0  "    Some aliases use pipes  - FAILS CHECK"
else
	t_echo 2  "    No aliases use pipes - PASSES CHECK"
fi 
rm -f ./tmpfile.$$
}

Fix() {
awk '/ *#/ {next} ; \
	/\|/ {print $0}' /etc/aliases > ./tmpfile.$$

if test -s ./tmpfile.$$ ; then
	t_echo 0 ""
	t_echo 0 "Removing existing mail alias(es) pipes":
	cat ./tmpfile.$$
	awk '/ *#/ { comment = 1 } ; \
		/\|/ { if (!comment) { pipe = 1; printf("# ") } } ; \
		{ print $0 ; comment = 0 }' /etc/aliases > aliases.titan
		cp /etc/aliases /etc/aliases.titan.$$
		mv -f aliases.titan /etc/aliases
else
	t_echo 2 "    decode disabled . PASSES CHECK"
fi

rm -f ./tmpfile.$$
}


action=$1
case $action in
 -[Ff]*)
Fix
;;
 -[Vv]*)
Check
;;
 -[Ii]*)
Intro
;;

*)
        t_echo 1 "        ERROR:Invalid arg $action"
        t_echo 1 "        ERROR:Usage $MYNAME -[ivf] (I)ntro/(V)erify/(F)ix"

        t_echo 1 " "
;;
esac




# List all files to save prior to changes this modules might make.
# Syntax is SAVEFILES='foo bar foobar'
#
SAVEFILES='/etc/aliases'
