:
#
# version 3.0 Sep 25 11:21:02 PDT 1998
# version 4.0 Thu Jan 25 11:19:01 PST 2001

umask 022
# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1992, 1993, 1994, 1995, 1996, 1997, 1998, 1999, 2000
#
# The copyright holder disclaims all responsibility or liability with 
# respect to its usage or its effect upon hardware or computer 
# systems, and maintains copyright as set out in the "LICENSE" 
# document which accompanies distribution. 

# setup
TITANHOME=`pwd`
PATH=/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`
DATE=`/bin/date +%m%d%y%H%M`
SAVEFILE=`/usr/sbin/in.routed`

OS=`uname -r`
#
# Names for original files
#
ORIG="orig"

# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi

#
# suck in some lib functions (t_echo, etc.)
#
. misc_functions.sh

Intro() {

cat << EOF


 This script configures routed to run in quiet mode. 
 In order to do this we:

   1) Move /usr/sbin/routed to /usr/sbin/routed.$ORIG
   2) Build a wrapper starting routed -q (quiet mode).

 You can modify this prior to running with -[Ff] to
 routed.orignal by editing the internal variable 
 ORIG in this shell script.

EOF
}


CheckRouted() {

 if [ -f /usr/sbin/routed.$ORIG ]; then
	grep "\-q" /usr/sbin/routed >/dev/null 2>&-
       if [ $? -eq 0 ]; then
        t_echo 2 "   "
        t_echo 2 " The route daemon is configured to not advertise routes - PASSES CHECK"
	exit 1
       else
        t_echo 1 "        Not the routed I expected - FAILS CHECK..."
       fi
 else       
        t_echo 0 "   "
        t_echo 0 "         The route daemon advertises routes - FAILS CHECK"
 fi

} # End CheckRouted


FixRouted() {

 grep "\-q" /usr/sbin/routed >/dev/null 2>&-
  if [ $? -eq 0 ]
   then
   t_echo 1
   t_echo 1 "ERROR - routed already a script - NO REPLACE"
   else
   t_echo 1 "Replacing routed with wrapper"
   if [ -x /usr/sbin/routed ]; then
   mv /usr/sbin/routed /usr/sbin/routed.$ORIG
   else
   t_echo 1 "No /usr/sbin/routed to fix - ERROR"
   exit 1
   fi
  fi
 
echo "#! /bin/sh" > /usr/sbin/routed
if [ $? -ne 0 ]
        then
        t_echo 1
        t_echo 1 "     ERROR - Could not create new ${ROUTED} script."
        exit 1
fi
echo "/usr/sbin/routed.$ORIG -q" >> /usr/sbin/routed
/bin/chmod 0755 /usr/sbin/routed
if [ $? -ne 0 ]
        then
        t_echo 1
        t_echo 1 "       ERROR - Could not chmod new ${ROUTED} script."
        exit 1
        fi
 
t_echo 2
t_echo 2 " Renamed routed to routed.$ORIG"
t_echo 2 " Installed new routed script."

} # End FixRouted


action=$1
case ${action} in
	-[Ii]*)
	Intro
	;;
	 -[Ff]*)
 	 FixRouted
	;;
	-[Vv]*)
	 CheckRouted
	;;
	*)
        t_echo 1 "        ERROR:Invalid arg $action"
        t_echo 1 "        ERROR:Usage $MYNAME -[ivf] (I)ntro/(V)erify/(F)ix"
        t_echo 1 " "
;;
esac


# List all files to save prior to changes this modules might make.
# Syntax is SAVEFILES='foo bar foobar'
#
SAVEFILES='/usr/sbin/routed'
