:
# dmi-2.6.sh
# version 3.0 Sep 25 11:21:02 PDT 1998
# version 3.0.3 Fri Jan  8 12:42:25 PST 1999 bpowell
# version 3.1.2 Tue Jun  1 11:59:39 PDT 1999 bpowell sugestions from maria_ng@gap.com
# version 3.4 Wed Feb 16 08:33:18 PST 2000 savefile variable added
# version 4.0

umask 022
# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1994, 1995, 1996, 1997, 1998, 1999, 2000
#
# The copyright holder disclaims all responsibility or liability with 
# respect to its usage or its effect upon hardware or computer 
# systems, and maintains copyright as set out in the "LICENSE" 
# document which accompanies distribution. 

# setup
TITANHOME=`pwd`
PATH=/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`
DATE=`/bin/date +%m%d%y%H%M`
SAVEFILES='/etc/init.d/init.dmi /etc/rc2.d/S77dmi /etc/rc3.d/S77dmi'

. misc_functions.sh

case "`uname -r`" in
5.[678]*) ;;
*)
        t_echo 1 "$MYNAME ERROR - This script is Only supported on Solaris 2.6 and newer, please use one of the other scripts for your OS "
        exit 1;;
esac

# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi

Intro() {

cat << EOF

 $MYNAME - Moves aside all the dmi daemons start up files 
 changing their names from S* to s* such that they do not start at boot
 DMI doesn't do any authentication ; allows core dumps and seems to allow you to
 start up arbitrary services. Thus we don't trust it to start.

EOF

}

Fix() {

  if [ -f /etc/init.d/init.dmi ]; then

     t_echo 2 "Stopping the running DMI daemon"
     /etc/init.d/init.dmi stop

     t_echo 2 " Saving /etc/init.d/init.dmi to /etc/init.d-init.dmi.ORIG.$DATE"
     mv /etc/init.d/init.dmi /etc/init.d-init.dmi.ORIG.$DATE
  fi    

if [ -f /etc/rc2.d/S??dmi -o /etc/rc3.d/S??dmi ] ; then
	for FILE in `ls /etc/rc*.d/S??dmi`
	do
	mv $FILE `echo $FILE | tr -s S s`
          if [ $? -ne 0 ]; then
           t_echo 1 "     ERROR:Could not rename $FILE ; exiting"
           exit 1
	  else
           t_echo 2 "Done ... "
          fi
	done
        fi

}

Check() {

        if [ -f /etc/init.d/init.dmi -o -f /etc/rc2.d/S??dmi -o -f /etc/rc3.d/S??dmi ]; then
           t_echo 0 "   dmi daemon is enabled  - FAILS CHECK"
	   exit 1
         else
           t_echo 1 "  dmi doesn't start at boot time -  PASSES CHECK" 
         fi

}

action=$1

   case ${action} in
	-[Ii]*)
	Intro
	;;
	-[Ff]*)
	Fix
	;;
	-[Vv]*)
	Check
	;;
	*)
        t_echo 1 "        ERROR:Invalid arg $action"
        t_echo 1 "        ERROR:Usage $0 -[ivf] (I)ntro/(V)erify/(F)ix"
	exit 1;;
	esac

