:
# inetsvc.sh
# version 3.4 Wed Feb 16 08:33:18 PST 2000 savefile variable added
# version 4.0.beta4

umask 022
# This tool suite was written by and is copyright by Brad Powell , Matt 
# Archibald, and Dan Farmer 1994, 1995, 1996, 1997, 1998, 1999, 2000, 2001, 2002
#
# The copyright holder disclaims all responsibility or liability with 
# respect to its usage or its effect upon hardware or computer 
# systems, and maintains copyright as set out in the "LICENSE" 
# document which accompanies distribution. 
 
# Some of the ideas and code for the sunos 4.1.X version of titan was 
# modified from code from a program secure_sun author unknown. If the 
# author of secure_sun (i believe it was from Texas A&M) wishes to identify 
# himself/herself I will gladly post credit where it is due- bpowell

# setup
TITANHOME=`pwd`
export TITANHOME 

PATH=/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`
OS=`uname -r`
HOST=`uname -n`
DATE=`/bin/date +%Y%m%d%H%M`
SAVEFILES='/etc/init.d/inetsvc /etc/rc2.d/S27inetsvc'
inetsvc="/etc/init.d/inetsvc"
# fix added since on some solaris releases inetsvc is linked to S72inetsvc
# instead of the other way around
inetsvc2="/etc/rc2.d/S72inetsvc"

. misc_functions.sh

# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
	# exit 1
	:
	fi

Intro() {

cat << EOF_INTRO

 $MYNAME - Moves aside /etc/init.d/inetsvc to /etc/init.d/inetsvc.ORIG.$DATE
 and replaces with a minimum version consisting of two lines:

  /usr/sbin/ifconfig -au netmask + broadcast +
  /usr/sbin/inetd -s -t

 Note: if you are running named (DNS server) DHCP, or multicast, you will have 
 to modify this.

EOF_INTRO

}

Check() {
 
if egrep -s "named|mcastif|dhcpinfo" $inetsvc
then
   t_echo 0 " File $inetsvc has services running that should be disabled - FAILS CHECK"
	t_echo 3 " "
	t_echo 3 "Titan Recommendation: (inetsvc.sh -f) Change /etc/init.d/inetsvc to a minimal"
	t_echo 3 "version consisting of two lines: "
	t_echo 3 " "
	t_echo 3 "  /usr/sbin/ifconfig -au netmask + broadcast + "
	t_echo 3 "  /usr/sbin/inetd -s -t "
	t_echo 3 " "
	t_echo 3 "Note- if you are running named (DNS server) DHCP, or multicast, you will have"
	t_echo 3 "to modify this. "
	t_echo 3 " "
	t_echo 3 "======================================================================== "

else
   t_echo 1 " $inetsvc seems to have had services disabled: PASSES CHECK"

fi

}

Fix() {

if [ -f $inetsvc.ORIG.$DATE ]
	then
	t_echo 2 "File $inetsvc.ORIG already exists; not changing"
else
	t_echo 2 "copying $inetsvc to $inetsvc.ORIG.$DATE"
	cp -p $inetsvc $inetsvc.ORIG.$DATE
	if [ $? -ne 0 ]
		then   
		t_echo 2
		t_echo 1 "Could not rename inetsvc -ERROR"
		exit 1
		fi
	fi
# inetsvc should be here if the above suceeded

if [ -f $inetsvc ]
	then
	t_echo 2 "Changing $inetsvc to the new version"
	t_echo 1 "Note: You may have to manually edit inetsvc if you use"
	t_echo 1 "DHCP, multicast, or this is a DNS (named) server."
	t_echo 1 "The existing version is saved as $inetsvc.ORIG.$DATE"
	t_echo 2 ""
	# we already saves a copy above, and had to use "cp because of symbolic
	# link issues, so we now remove the origional so we can start with a fresh
	# install 
	rm $inetsvc
	rm $inetsvc2

/bin/cat << EOF_INETSVC > $inetsvc
#!/sbin/sh

case "\$1" in
'start')
/usr/sbin/ifconfig -au netmask + broadcast +
/usr/sbin/inetd -s -t
;;
'stop')
        /usr/bin/pkill -x -u 0 'in.named|inetd'
        exit 0
        ;;

*)
        echo "Usage: inetsvc { start | stop }"
        exit 1
        ;;
esac

EOF_INETSVC

	/bin/chmod 644 $inetsvc
# now we link the /etc/rc2.d/S72inetsvc to the new version
	ln /etc/init.d/inetsvc /etc/rc2.d/S72inetsvc
	fi

}

action=$1
case $action in
	-[Ff]*)
	Fix
	;;
	-[Vv]*)
	Check
	;;
	-[Ii]*)
	Intro
	;;
        *) 
          t_echo 1 " " 
          t_echo 1 "        ERROR:Invalid arg $action" 
          t_echo 1 "        ERROR:Usage $MYNAME -[ivfc] (I)ntroduction/(V)erify/(F)ix/(C)configfile" 
          t_echo 1 " " 
        ;; 
        esac 

