:
# smtp-banner.sh
# version 3.0 Sep 25 11:21:02 PDT 1998
# version 3.0.1 Mon Dec 14 10:53:10 PST 1998 change line 64 output to match actual check
# version 3.4 Wed Feb 16 08:33:18 PST 2000 savefile variable added
# version 4.0

umask 022
# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1994, 1995, 1996, 1997, 1998, 1999, 2000
#
# The copyright holder disclaims all responsibility or liability with 
# respect to its usage or its effect upon hardware or computer 
# systems, and maintains copyright as set out in the "LICENSE" 
# document which accompanies distribution. 

# setup
TITANHOME=`pwd`
PATH=/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`
DATE=`/bin/date +%m%d%y%H%M`
SAVEFILES='/etc/mail/sendmail.cf'
OS=`uname -r`

# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi
 
#
# suck in some lib functions (t_echo, etc.)
#
. misc_functions.sh

Intro() {
cat << EOF

 $MYNAME This changes the sendmail banner to not report what mail 
 version is running. It changes your login banner from something 
 like This:
 
	Sendmail SMI-8.6/SMI-SVR4 ready at Fri, 2 May 1997

		TO

     	Sendmail Server Ready


EOF
}

Check() {

if [ -f /etc/mail/sendmail.cf ]; then

 if [ -f /etc/mail/sendmail.cf.titan1 ]; then

  t_echo 3 " File /etc/mail/sendmail.cf.titan1 exists - Checking content"
  grep "Sendmail Server Ready" /etc/mail/sendmail.cf >/dev/null

  if [ $? -ne 0 ]; then
   t_echo 1 "         A config file is in place but the banner still give out info - ERROR"
   exit 1
  else
   t_echo 1 "         Sendmail Server Ready message in place - PASSES CHECK"
  fi

 else
   t_echo 0 "         No /etc/mail/sendmail.cf.titan1 exists - FAILS CHECK"
 fi

else
 t_echo 1 ""
 t_echo 2 "         No /etc/mail/sendmail.cf exists"
 t_echo 3 "         Could not save current semdmail.cf or could not find it"
 exit 1
fi

}

Fix() {

# Here is where we add in the option 

if [ -f /etc/mail/sendmail.cf ]; then

 cp /etc/mail/sendmail.cf /etc/mail/sendmail.cf.titan1 >/dev/null

 if [ $? -eq 0 ]; then
 t_echo 2 " Changing the Sendmail Ready line "

ed - /etc/mail/sendmail.cf <<- !
g/De\$j Sendmail \$v\/\$V ready at \$b/s/De\$j Sendmail \$v\/\$V ready at \$b/De Sendmail Server Ready/
w
q
!

 t_echo 2 "     "
 t_echo 2 " Sendmail login message changed"
 t_echo 2 "     "
 else
 t_echo 1 " Could not backup /etc/mail/sendmail.cf - ERROR"
 exit 1
 fi
fi

} # End FixBanner


action=$1
case $action in
	-[Ii]*)
	Intro
	;;
	 -[Ff]*)
	 Fix
	;;
	-[Vv]*)
	 Check
	;;
	*)
        t_echo 1 "         ERROR:Invalid arg $action"
        t_echo 1 "         ERROR:Usage $MYNAME -[ivf] (I)ntro/(V)erify/(F)ix"
        t_echo 1 " "
;;
esac
