:
# disable-NFS.bind.sh
# version 3.0 Sep 25 11:21:02 PDT 1998
# version 3.0.3 Fri Jan  8 18:42:25 PST 1999
# version 3.2.2 Mon Nov  1 10:13:37 PST 1999
# version 3.4 Wed Feb 16 08:33:18 PST 2000 savefile variable added
# version 4.0

umask 022
# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1994, 1995, 1996, 1997, 1998, 1999, 2000
#
# The copyright holder disclaims all responsibility or liability with 
# respect to its usage or its effect upon hardware or computer 
# systems, and maintains copyright as set out in the "LICENSE" 
# document which accompanies distribution. 

# setup
TITANHOME=`pwd`
PATH=/usr/sbin:/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`
DATE=`/bin/date +%m%d%y%H%M`
SAVEFILES='/etc/rc2.d/S??inet /etc/rc3.d/S??inet'


# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi

#
# suck in some lib functions (t_echo, etc.)
#
. misc_functions.sh

 
case "`uname -r`" in
5.[2345]*) ;;
*)
        t_echo 1 "$MYNAME : ERROR - This script is Only needed on Solaris 2.5.1 and older" 
        t_echo 1 "Please us the disable-NFS-2.6.sh for your OS"
        exit 1;;
esac


Intro() {
cat << EOF
 $MYNAME : This changes the privileged port definition to above port
 2050 thus making the NFS server port (2049) be a privileged Unix port
 This eliminates some of the port looping through rpcbind tricks and
 some of the other NFS access tricks

 The program modifies /etc/rc2.d/S??inet adding in the lines:

  ndd -set /dev/udp udp_smallest_nonpriv_port 2050
  ndd -set /dev/tcp tcp_smallest_nonpriv_port 2050
EOF

}

Check() {
   t_echo 3 "        Verifying port settings using ndd "
   PRIVPORT=` ndd /dev/tcp tcp_smallest_nonpriv_port`
   t_echo 0 " privileged port definition is currently set to $PRIVPORT - FAILS CHECK"
   if [ $PRIVPORT != 2050 ]; then
   t_echo 2 ""
    else
   t_echo 2 " "
   t_echo 1 "     privileged port definition is set above 2050  -  PASSES CHECK "
   t_echo 2 " "
   fi
 
   if [ -z "$PRIVPORT" ]; then
   t_echo 0 "No speficic port settings found - FAILS CHECK "
    else
   t_echo 2 " "
   exit 1
   fi
}

Fix() {
 t_echo 3 " Setting privileged port above 2050..."
 
 if [ -f /etc/rc2.d/S??inet -o /etc/rc3.d/S??inet ]; then
    for FILE in `ls /etc/rc*.d/S??inet`
	do
  egrep '(tcp_smallest_nonpriv|udp_smallest_nonpriv)' $FILE >/dev/null 2>&-

  if [ $? -eq 0 ]; then
  t_echo 1 "privileged port setting ok - PASSES CHECK "
  else
  t_echo 2 " Adding in the ndd option to raise privileged ports to 2050"
  t_echo 2 "	Modifications: "
ed - $FILE << EOEF
a
	ndd -set /dev/udp udp_smallest_nonpriv_port 2050
	ndd -set /dev/tcp tcp_smallest_nonpriv_port 2050
.
w
q
EOEF
  t_echo 3 "Setting privileged port definitions to 2050 now..."
fi
 
	ndd -set /dev/udp udp_smallest_nonpriv_port 2050
	ndd -set /dev/tcp tcp_smallest_nonpriv_port 2050
  t_echo 3 "REPAIRED"
	done
else

  t_echo 3 "No ndd definitions in /etc/rc?.d/S??inet found"
fi
 }
 
action=$1
	 case ${action} in
	-[Ii]*)
	Intro
	;;
	  -[Ff]*)
	 Fix
	 ;;
	 -[Vv]*)
	 Check
	 ;;
	 *)
         t_echo 1 "        ERROR: Invalid arg $action - Exiting"
         t_echo 1 "        ERROR:Usage disable-NFS.bind.sh -[ivf] (I)ntro/(V)erify/(F)ix"
	 exit 1
	 ;;
	 esac
