:
# disable-core.sh
# version 3.0 Sep 25 11:21:02 PDT 1998
# version 3.0.3 Fri Jan  8 18:42:25 PST 1999 bpowell
# version 3.4 Wed Feb 16 08:33:18 PST 2000 savefile variable added
# version 4.0.10

umask 022
# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1994, 1995, 1996, 1997, 1998, 1999, 2000
#
# The copyright holder disclaims all responsibility or liability with
# respect to its usage or its effect upon hardware or computer
# systems, and maintains copyright as set out in the "LICENSE"
# document which accompanies distribution.

# setup
TITANHOME=`pwd`
PATH=/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`
DATE=`/bin/date +%m%d%y%H%M`
SAVEFILES='/etc/coreadm.conf'

# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi
 
. misc_functions.sh

case "`uname -r`" in 
5.[89]*) ;; 
*) 
 t_echo 1 " $MYNAME ERROR - Only supported on Solaris 2.8 and newer"
        exit 1;; 
esac


Intro() {

cat << EOF

 $MYNAME - This changes the /etc/coradm.conf file to disable global core
 dumps. This prevents bad-guys forcing a core dump to examine any information
 that might be stored in the core. Reference the old bug where you could 
 force a core with gcore of processes like rpc.pwauthd

EOF

}

Fix() {
        if [ -f /etc/coreadm.conf ] ; then
        t_echo 2 "   /etc/coreadm.conf exists "
        t_echo 2 "   saving a copy of the old /etc/coreadm.conf to /etc/coreadm.conf.Titan.$DATE"
        cp -p /etc/coreadm.conf /etc/coreadm.conf.Titan.$DATE
                if [ $? -ne 0 ]
                then
                        t_echo 1
                        t_echo 1 "Could not rename /etc/coreadm.conf; exiting"
                        exit 1
                fi
        fi
 
# we now use "coreadm -d global" to disable global core dumps
coreadm -d global
coreadm -d process
coreadm -d log
# if the file isn't there create it
 
        if [  ! -f /etc/coreadm.conf ] ; then
        t_echo 0 "   Creating /etc/coreadm.conf and limiting core files"
        /bin/cat << EOF2 > /etc/coreadm.conf
#
#coreadm.conf
# Modified by Titan
#
EOF2
# we now use "coreadm -d global" to disable global core dumps
coreadm -d global
coreadm -d process
coreadm -d log
fi

# if the file is there append to it

if [  -f /etc/coreadm.conf ]; then
        t_echo 0 "   Changing /etc/coreadm.conf to limit core filesize"
# we now use "coreadm -d global" to disable global core dumps
	coreadm -d global
	coreadm -d process
	coreadm -d log
        /bin/cat << EOF3 >> /etc/coreadm.conf

#
# coreadm.conf modified by Titan
EOF3

	t_echo 2 "   Core files have been disabled"
        else
        t_echo 0 "   Core dump size has not been set:  FAILS CHECK "
fi

/bin/chmod 644 /etc/coreadm.conf
}

Check() {

if [ -f /etc/coreadm.conf ] ; then
	coreadm | grep "enabled"
	if [ $? -eq 0 ]; then
	t_echo 0 " One or more core dumps permitted - FAILS CHECK"
        t_echo 3 " "
        t_echo 3 "Titan Recommendation: (disable-core.sh -f) Unless the system is having hardware"
        t_echo 3 "problems, allowing coredumps is illadvised as it allows users to attempt to"
        t_echo 3 "overflow the stack on suid binaries and creat suid "shells" Titan recommends"
        t_echo 3 "adding the following to /etc/system:"
        t_echo 3 "Note-  the "*" is a comment line in /etc/system (instead of "#") "
        t_echo 3 "* added to limit core file size "
        t_echo 3 "set sys:coredumpsize = 0 "
        t_echo 3 " "
        t_echo 3 "And also use the following coradm settings:"
        t_echo 3 "   coreadm -d global"
        t_echo 3 "   coreadm -d process"
        t_echo 3 "   coreadm -d log "
        t_echo 3 " "
        t_echo 3 "======================================================================== "

	else
	t_echo 1 " Core dump size has been set: PASSES CHECK"
	fi
fi

}

action=$1
 
   case ${action} in
        -[Ii]*)
        Intro
        ;;
        -[Ff]*)
        Fix
        ;;
        -[Vv]*)
        Check
        ;;
        *)
        t_echo 1 "        ERROR:Invalid arg $action"
        t_echo 1 "        ERROR:Usage $0 -[ivf] (I)ntro/(V)erify/(F)ix"
        exit 1
	;;
        esac


