:
# nddconfig2.8.sh 
# version 3.0 Sep 25 11:21:02 PDT 1998
# version 3.2 Thu Sep 30 08:35:25 PDT 1999
# lib/nddconfig (/etc/init.d/nddconfig work done by Keith Watson (kaw@Eng.Sun.COM)
# version 3.4 Wed Feb 16 08:33:18 PST 2000 savefile variable added
# version 3.6 Wed April 19 18:33:18 PST 2000 bpowell solaris 8 ndd name change
# version 4.0 beta1

umask 022
# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1994, 1995, 1996, 1997, 1998, 1999, 2000, 2001
#
# The copyright holder disclaims all responsibility or liability with 
# respect to its usage or its effect upon hardware or computer 
# systems, and maintains copyright as set out in the "LICENSE" 
# document which accompanies distribution. 

# setup
TITANHOME=`pwd`
PATH=/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`
DATE=`/bin/date +%m%d%y%H%M`
SAVEFILES='/etc/init.d/nddconfig /etc/rc2.d/S70nddconfig'
OS=`uname -r`

# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi

. misc_functions.sh

case "`uname -r`" in
5.[89]*) ;;
*)
        t_echo 1 "$MYNAME ERROR - This script is Only supported on Solaris 2.8 and newer"
        t_echo 1 "see nddconfig.sh for older solaris releases"
        exit 1;;
esac
 

Intro() {
cat << EOF

 $MYNAME - This program creates a file /etc/init.d/nddconfig and sets
 many of the tunable network kernel parameters to a secure setting. This 
 will OVERRIDE other settings that are set in the /etc/rc*.d scripts. The
 settings modified are changed to:

                '0' indicates false/off.
                '1' indicates true/on.

     ARP_CLEANUP_INTERVAL=60000 (one minute)
     IP_FORWARD_DIRECTED_BROADCASTS=0
     IP_FORWARD_SRC_ROUTED=0
     IP_IGNORE_REDIRECT=1
     IP_IRE_ARP_INTERVAL=60000  (one minute)
     IP_RESPOND_TO_ADDRESS_MASK_BROADCAST=0
     IP_RESPOND_TO_ECHO_BROADCAST=0
     IP_RESPOND_TO_TIMESTAMP=0
     IP_RESPOND_TO_TIMESTAMP_BROADCAST=0
     IP_SEND_REDIRECTS=0
     IP_STRICT_DST_MULTIHOMING=1
     TCP_CONN_REQ_MAX_Q0=4096
     TCP_MSS_MIN=68

     Read through the lib/nddconfig script for a full explanation of each setting

 You may note that many of these settings are used in other Titan modules. 
 The older modules (adjust-arp-timers.sh, adjust.syn-timeout.sh, disable_ip_holes.sh)
 have been retained since running those as well as this one does no harm, and
 give you the ability to choose the modules that best fit your system type and
 security policy. 

Note: On clustered systems IP_STRICT_DST_MULTIHOMING may need to be reset to the default
      As long as the clustered system is not exposed to the Internet, or other hostile
      network this is probably not going to be a security issue, assuming your firewall
      blocks spoofed addresses. 

EOF

}

Check() {
        if [ -f /etc/init.d/nddconfig ]; then
       t_echo 1 "        nddconfig exists as /etc/init.d/nddconfig - PASSES CHECK"
       t_echo 3 " "
       else
       t_echo 0 "        /etc/init.d/nddconfig does not  exists - FAILS CHECK"
	t_echo 3 " "
	t_echo 3 "Titan Recommendation: (nddconfig.sh -f) All network security settings should be"
	t_echo 3 "set to rerun after every reboot "
	t_echo 3 "Titan creates  /etc/init.d/nddconfig and modifies it to contain: "
	t_echo 3 " "
	t_echo 3 "                '0' indicates false/off. "
	t_echo 3 "                '1' indicates true/on. "
	t_echo 3 " "
	t_echo 3 "     ARP_CLEANUP_INTERVAL=60000 (one minute) "
	t_echo 3 "     IP_FORWARD_DIRECTED_BROADCASTS=0 "
	t_echo 3 "     IP_FORWARD_SRC_ROUTED=0 "
	t_echo 3 "     IP_IGNORE_REDIRECT=1 "
	t_echo 3 "     IP_IRE_ARP_INTERVAL=60000  (one minute) "
	t_echo 3 "     IP_RESPOND_TO_ADDRESS_MASK_BROADCAST=0 "
	t_echo 3 "     IP_RESPOND_TO_ECHO_BROADCAST=0 "
	t_echo 3 "     IP_RESPOND_TO_TIMESTAMP=0 "
	t_echo 3 "     IP_RESPOND_TO_TIMESTAMP_BROADCAST=0 "
	t_echo 3 "     IP_SEND_REDIRECTS=0 "
	t_echo 3 "     IP_STRICT_DST_MULTIHOMING=1 "
	t_echo 3 "     TCP_CONN_REQ_MAX_Q0=4096 "
	t_echo 3 "     TCP_MSS_MIN=68 "
	t_echo 3 " "
	t_echo 3 "     Read through the lib/nddconfig script for a full explanation of each setting"
	t_echo 3 " "
	t_echo 3 "Note- many of these settings are used in other Titan modules. The older modules"
	t_echo 3 "(adjust-arp-timers.sh, adjust.syn-timeout.sh, disable_ip_holes.sh) have been"
	t_echo 3 "retained since running those as well as this one does no harm, and give you the"
	t_echo 3 "ability to choose the settings that best fit your system type.  "
	t_echo 3 " "
	t_echo 3 "======================================================================== "

        fi
}

Fix() {

if [ -f /etc/init.d/nddconfig ]; then
        t_echo 1 "        nddconfig already exists as /etc/init.d/nddconfig  "
else
 t_echo 2 "        Building /etc/init.d/nddconfig "

# we check for the file in the lib subdirectory first
if [ -f ./lib/nddconfig2.8 ]; then
/bin/cat ./lib/nddconfig2.8 >/etc/init.d/nddconfig
chmod 555 /etc/init.d/nddconfig
ln /etc/init.d/nddconfig /etc/rc2.d/S70nddconfig 
else
/bin/cat nddconfig2.8 > /etc/init.d/nddconfig
chmod 555 /etc/init.d/nddconfig
ln /etc/init.d/nddconfig /etc/rc2.d/S70nddconfig 
fi

if [ -f /etc/init.d/nddconfig ]; then   
 t_echo 2 ""
 t_echo 2 "        File /etc/init.d/nddconfig created"
else
 t_echo 1 "        /etc/init.d/nddconfig not created - ERROR"
 t_echo 2 " "
fi 
fi
}


action=$1
	case ${action} in
	-[Ii]*)
	Intro
	;;
	 -[Ff]*)
	Fix
	;;
	-[Vv]*)
	Check
	;;
	*)
        t_echo 1 "        ERROR:Invalid arg $action"
        t_echo 1 "        ERROR:Usage $MYNAME -[ivf] (I)ntro/(V)erify/(F)ix"
        t_echo 1 " "
	;;
	esac
