:
# nsswitch.sh
# version 3.0 Sep 25 11:21:02 PDT 1998
# version 3.4 Wed Feb 16 08:33:18 PST 2000 savefile variable added
# version 4.0

umask 022
# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1994, 1995, 1996, 1997, 1998, 1999, 2000
#
# The copyright holder disclaims all responsibility or liability with 
# respect to its usage or its effect upon hardware or computer 
# systems, and maintains copyright as set out in the "LICENSE" 
# document which accompanies distribution. 

# setup
TITANHOME=`pwd`
PATH=/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`
SAVEFILES='/etc/nsswitch.conf'
DATE=`/bin/date +%m%d%y%H%M`
OS=`uname -r`

# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi

. misc_functions.sh

Intro() {

cat << EOF

 $MYNAME - This script does a simple move of the /etc/nsswitch.conf file to
 /etc/nsswitch.conf.ORIG and then creates a new file based on existing
 entries which utilizes 'files' only as the resolution service.
 This ensures that the host will not look to any other name
 services such as DNS or NIS(+) for network services.

EOF
}

Fix() {

	if [ ! -f /etc/nsswitch.conf ]
	then
           t_echo 1 "   ERROR  - could not find /etc/nsswitch.conf; exiting"
	exit 1
	else
           t_echo 2 "Fixing /etc/nsswitch.conf..."
           t_echo 2 "Creating a new nsswitch.conf based on existing content.."

	for entry in `grep -v "^#" /etc/nsswitch.conf | \
			awk -F":" '{print $1}' | grep "[A-z]"`
	do
 echo "$entry\: files" | sed -e 's/\\//' >>/etc/nsswitch.conf.$$
	done

 t_echo 2 "Updates complete...."
 echo "Moving /etc/nsswitch.conf -> /etc/nsswitch.conf.ORIG.$DATE"
	mv /etc/nsswitch.conf /etc/nsswitch.conf.ORIG.$DATE
 echo "Moving /etc/nsswitch.conf.$$ -> /etc/nsswitch.conf"
	mv /etc/nsswitch.conf.$$ /etc/nsswitch.conf
        # Added this line because the new nsswitch.conf file was being created under
        # the group "other"
        chgrp sys /etc/nsswitch.conf
	/bin/cat /etc/nsswitch.conf
	fi

}

Check() {

STAT=0
COUN=0

       if [ ! -f /etc/nsswitch.conf ]
	then
         t_echo 1 "   ERROR -  could not find /etc/nsswitch.conf; exiting"
	 exit 1
	else
	 for entry in `grep -v "^#" /etc/nsswitch.conf | \
			awk -F":" '{print $1}' | grep "[A-z]"`
	 do
	 COUN=`expr $COUN + 1`
	 SRVC=`grep "^$entry" /etc/nsswitch.conf | awk '{print $2}'`
	 if [ "$SRVC" = "files" ]; then
            t_echo 1 "       $entry -> $SRVC - PASSES CHECK"
	    STAT=`expr $STAT + 1`
	 else
            t_echo 0 "      $entry -> $SRVC - FAILS CHECK"
        t_echo 3 " "
        t_echo 3 "Titan Recommendation: (nsswitch -f)  /etc/nsswitch.conf should be modified to"               
        t_echo 3 "ensure the system only looks to files and not NIS(+) or DNS. "
        t_echo 3 " "
        t_echo 3 "   networks: files  "
        t_echo 3 "   protocols: files "
        t_echo 3 "   rpc: files "
        t_echo 3 "   ethers: files "
        t_echo 3 "   netmasks: files  "
        t_echo 3 "   bootparams: files "
        t_echo 3 "   publickey: files  "
        t_echo 3 "   netgroup: files  "
        t_echo 3 "   automount: files  "
        t_echo 3 "   aliases: files "
        t_echo 3 "   services: files  "
        t_echo 3 "   sendmailvars: files "
        t_echo 3 "   printers: files  "
        t_echo 3 "   auth_attr: files  "
        t_echo 3 "   prof_attr: files  "
        t_echo 3 "   project: files "
        t_echo 3 " "
        t_echo 3 "======================================================================== "

	 fi
	done
       fi

	if [ $STAT -eq $COUN ]; then
         t_echo 1 "$STAT of $COUN entries set to files as default - PASSES CHECK "
	 exit 0
	else
         t_echo 0 "$STAT of $COUN entries PASSES CHECK others should be fixed.."
	fi

}


action=$1
	case ${action} in
	-[Ii]*)
	Intro
	;;
	 -[Ff]*)
	Fix
	;;
	-[Vv]*)
	Check
	;;
	*)
	 t_echo 1 "       ERROR:Invalid arg $action"
	 t_echo 1 "       ERROR:Usage $MYNAME -[ivf] (I)ntro/(V)erify/(F)ix"
	 t_echo 1 " "
	;;
	esac
