:
# nuke-smc.sh
# version 4.0beta1 Thu Jun 21 15:58:32 PDT 2001

umask 022
# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1994, 1995, 1996, 1997, 1998, 1999, 2000, 2001
#
# The copyright holder disclaims all responsibility or liability with 
# respect to its usage or its effect upon hardware or computer 
# systems, and maintains copyright as set out in the "LICENSE" 
# document which accompanies distribution. 

# setup
TITANHOME=`pwd`
PATH=/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`
DATE=`/bin/date +%m%d%y%H%M`
SAVEFILES='/etc/rc2.d/S90wbem'
OS=`uname -r`

# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi

. misc_functions.sh

Intro () {

cat << EOF

 $MYNAME -  Script to keep SMC (Solaris Management Console) starting in the 
 /etc/rc2.d/S90wbem script. We disable this because:
	a) if your not using it it can be abused by attackers
	b) If someone probes you from remote (nessus) the server starts
	   processes on your system which chew up CPU.

 This script takes advantage of the fact that /etc/rc?.d files that begin with
 a "K" get sent the stop/kill command, thus we simply move S90wbem to K90wbem

EOF

}

Fix() {

if [ -f /etc/rc2.d/S90wbem -o -f /etc/rc3.d/S90wbem ] ; then
      for FILE in `ls /etc/*.d/S90wbem`
       do
	cp -p $FILE `echo $FILE | tr -s S s`.ORIG.$DATE
	t_echo 2 " saving origional $FILE to `echo $FILE | tr -s S s`.ORIG.$DATE"
	t_echo 2 " renaming $FILE to disable smc service"
	mv $FILE `echo $FILE | tr -s S s`
      done
fi

}

Check() {

if [ -f /etc/*.d/S90wbem ]; then

      for FILE in `ls /etc/*.d/S90wbem`
       do
	t_echo 0 " Solaris Management Console is enabled in ${FILE} - FAILS CHECK"
	done
        t_echo 3 " "
        t_echo 3 "Titan Recommendation: (nuke-smc.sh -f) Any system not specifically
needing SMC"
        t_echo 3 "Sun management service should have them disabled. Otherwise remote"        t_echo 3 " users will be able to start up SMC and remotely administer"
        t_echo 3 " your system. Titan disables SMC. "
        t_echo 3 " "
        t_echo 3 "======================================================================== "

	else
	t_echo 1 " Solaris Management Console is disabled from starting  - PASSES CHECK"
	fi
}

action=$1
	case ${action} in
	-[Ii]*)
	Intro
	;;
	 -[Ff]*)
	Fix
	;;
	-[Vv]*)
	Check
	;;
	*)
        t_echo 1 "        ERROR:Invalid arg $action"
        t_echo 1 "        ERROR:Usage $MYNAME -[ivf] (I)ntro/(V)erify/(F)ix"
        t_echo 1 " "
	;;
	esac


